//
//
//	Customizable Z-Scale Building - roof
//	By Stephen Baird
//	Heavily based on "Customizable Modular Building"
// By Steve Medwin
//	(Thanks other Steve!)
//
//	April 2015
//




// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//	CONFIGURATION
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

//
// Basic Options
//

// Number of horizontal windows
horizontal_windows=3; //[1:10]
Ncol=horizontal_windows;
// Number of vertical windows
vertical_windows=1; //[1:5]
Nrow=vertical_windows;

//
// Advanced Options
//

// windows
Xinit=8*1; // Distance from left edge to first window
Yinit=2*1; //5 Distance from bottom to first window row
Xspace=10*1; // Distance from left edge of window to next left edge of window
Yspace=15.5*1; // Distance from bottom of window row to next row
Zbase=4.0*1; // Thickness of wall
Xwin=6.4*1; // (6.4) Width of window
Ywin=12*1; // Height of window
Yheight=5*1; //make double tall first floor
Zwin=2*1; // Depth of windows
Xmuntin=1*1; // Height of window muntin
Ymuntin=Xmuntin;
Zmuntin=0.8*1; // Thickness of window muntin
YwinArc=0.25*1; // Parameter for top of window arc
Xjam=1.0*1; //Width of door jam

Xbase=Xinit*2+Xspace*(Ncol-1)+Xwin; // Width of wall
Ybase=Yinit*2+Yspace*(Nrow-1)+Yheight+2.97; // Height of wall without roof
Xdoor=(Xspace+Xwin)/2-Xwin-Xjam/2;


// !!!!!!!!!!!!!!!!!!!!!!!!!!
// BEGIN PROGRAM
// !!!!!!!!!!!!!!!!!!!!!!!!!!

//roof_top(0);

module roof_top(Num){
if (Num - 1 > 0){
for (j = [0:Num-1]){
translate([0,0,-Xbase*j]){
for (i = [0:Num -1]){
translate([Xbase*i,0,0]) roof();
}
}
}
}
if (Num - 1 <= 0){
roof();
}
}



//Roof plate
module roof(){
difference(){
translate([0,-1+Ybase/2,-4-Xbase]) cube([Xbase,4,Xbase]);
for(i = [0:8]){
translate([5*i,2+Ybase/2,-5-Xbase]) cube([.5,5,Xbase+2]);
translate([0,2+Ybase/2,-5-Xbase+1.9+5*i]) cube([Xbase+2,5,.5]);
}
rotate ([0,-90,0]){	
for (i =[0:3]){
		hull(){
			translate([-4,-Ybase/6+2*Ybase/3,-1-(.4*Xinit+.65+Xspace*i)]) cube([.1,1,1]);
			translate([-5,-Ybase/6+2*Ybase/3+.45,-1-(.3*Xinit+.65+Xspace*i)]) cube([.1,.1,.1]);
		}
}}
mirror([0,0,1]){
rotate ([0,180,0]){	
for (i =[0:3]){
		hull(){
			translate([0,-Ybase/6+2*Ybase/3,-5-(.4*Xinit+.65+Xspace*i)]) cube([.1,1,1]);
			translate([-1,-Ybase/6+2*Ybase/3+.45,-5-(.3*Xinit+.65+Xspace*i)]) cube([.1,.1,.1]);
		}
}}}
mirror([1,0,0]){
rotate ([0,180,0]){	
for (i =[0:3]){
		hull(){
			translate([Xbase,-Ybase/6+2*Ybase/3,-(-4-(.4*Xinit+.65+Xspace*i))]) cube([.1,1,1]);
			translate([Xbase-1,-Ybase/6+2*Ybase/3+.45,-(-5-(.3*Xinit+.65+Xspace*i))]) cube([.1,.1,.1]);
		}
}}}
}
rotate ([0,-90,0]){	
for (i =[0:3]){
		hull(){
			translate([-4-Xbase,-Ybase/6+2*Ybase/3,-1-(.4*Xinit+.65+Xspace*i)]) cube([.1,1,1]);
			translate([-5-Xbase,-Ybase/6+2*Ybase/3+.45,-1-(.3*Xinit+.65+Xspace*i)]) cube([.1,.1,.1]);
		}
}}}

$fn=36*1;
use <MCAD\shapes.scad>